<?xml version="1.0" encoding="UTF-8"?>
<project name="build-pert" default="all" basedir=".">
    <target name="init">
        <!-- gobal build properties -->
        <property file="build.properties"/>
        
        <!-- properties for copyright and versioning -->
        <property name="name" value="JHotDraw: PERT Sample"/>

        <!-- build properties -->
        <property name="libdir" value="lib"/>
        <property name="srcdir" value="src/main/java"/>
        <property name="builddir" value="build"/>
        <property name="classdir" value="${builddir}/classes"/>
        <property name="distdir" value="dist/JHotdraw ${version}/Samples/PERT"/>

        <!-- properties for jar signing -->
        <property name="keystore.file" value="../../../../_Keystore/JavaKeystore.jks"/>
        <property file="${keystore.file}.properties"/>
    </target>
    <target name="clean" depends="init">
        <delete dir="${classdir}" />
    </target>
    <target name="applet.compile" depends="init,clean">
        <mkdir dir="${classdir}"/>
        <javac
                destdir="${classdir}"
                srcdir="${srcdir}"

                debug="${javac.debug}"
                optimize="${javac.optimize}"
                encoding="${javac.encoding}"
                includeantruntime="${javac.includeantruntime}"
                source="${javac.source}"
                target="${javac.target}"
                bootclasspath="${javac.bootclasspath}"
                classpath="${javac.classpath}"
                extdirs="${javac.extdirs}"
        >
            <classpath path="${libdir}/java_30.zip"/>
            <classpath path="${libdir}/annotations.jar"/>
            <classpath path="${libdir}/jsr305.jar"/>
            <include name="org/jhotdraw/samples/pert/PertApplet.java"/> 
            <include name="net/n3/nanoxml/*.java"/> 
        </javac>
        <copy todir="${classdir}/org/jhotdraw/app/action/images">
            <fileset dir="${srcdir}/org/jhotdraw/app/action/images" >
                <include name="edit*.png"/>
            </fileset>
        </copy>
        <copy todir="${classdir}/org/jhotdraw/draw/action/images">
            <fileset dir="${srcdir}/org/jhotdraw/draw/action/images" />
        </copy>
        <copy todir="${classdir}/org/jhotdraw/undo">
            <fileset dir="${srcdir}/org/jhotdraw/undo">
                <include name="*.properties"/>
            </fileset>
        </copy>
        <copy todir="${classdir}/org/jhotdraw/undo/images">
            <fileset dir="${srcdir}/org/jhotdraw/undo/images">
                <include name="*.png"/>
            </fileset>
        </copy>
        <copy todir="${classdir}/org/jhotdraw/draw">
            <fileset file="${srcdir}/org/jhotdraw/draw/Label*.properties"/>
        </copy>
        <copy todir="${classdir}/org/jhotdraw/gui">
            <fileset dir="${srcdir}/org/jhotdraw/gui">
                <include name="*.properties"/>
            </fileset>
        </copy>
        <copy todir="${classdir}/org/jhotdraw/app">
            <fileset file="${srcdir}/org/jhotdraw/app/Label*.properties"/>
        </copy>
        <copy todir="${classdir}/org/jhotdraw/samples/pert">
            <fileset file="${srcdir}/org/jhotdraw/samples/pert/Label*.properties"/>
        </copy>
        <copy todir="${classdir}/org/jhotdraw/samples/pert/images">
            <fileset file="${srcdir}/org/jhotdraw/samples/pert/images/*.png"/>
        </copy>
    </target>
    <target name="applet.jar" depends="init,applet.compile">
        <mkdir dir="${distdir}/unsigned"/>
        <jar destfile="${distdir}/unsigned/jhotdraw_pert.jar" basedir="${classdir}"
        index="true" compress="false">
            <manifest>
                <attribute name="Main-Class" value="org.jhotdraw.samples.pert.PertApplet"/>
                
                <!-- versioning -->
                <attribute name="Created-By" value="${author}"/>
                <attribute name="Built-By" value="${author}"/>
                <attribute name="Specification-Title" value="${name}"/>
                <attribute name="Specification-Version" value="${version}"/>
                <attribute name="Specification-Vendor" value="${author}"/>
                <attribute name="Implementation-Title" value="${name}"/>
                <attribute name="Implementation-Version" value="${version}"/>
                <attribute name="Implementation-Vendor" value="${author}"/>
                
                <!-- applet security -->
                <attribute name="Application-Name" value="${name}"/>
                <attribute name="Application-Library-Allowable-Codebase" value="*"/>
                <attribute name="Caller-Allowable-Codebase" value="*"/>
                <attribute name="Codebase" value="*"/>
                <!-- attribute name="Entry-Point" value=""/-->
                <attribute name="Permissions" value="sandbox"/>
                <attribute name="Trusted-Library" value="false"/>
                <attribute name="Trusted-Only" value="false"/>
            </manifest>
        </jar>
        <exec executable="gzip" dir="${distdir}/unsigned">
            <arg value="-f"/>
            <arg value="jhotdraw_pert.jar"/>
        </exec>
        <jar destfile="${distdir}/unsigned/jhotdraw_pert.jar" basedir="${classdir}" index="true">
            <manifest>
                <attribute name="Built-By" value="${author}"/>
                <attribute name="Main-Class" value="org.jhotdraw.samples.pert.PertApplet"/>
                <attribute name="Implementation-Version" value="${version}"/>
            </manifest>
        </jar>
        <exec executable="pack200">
            <arg value="${distdir}/unsigned/jhotdraw_pert.jar.pack.gz"/>
            <arg value="${distdir}/unsigned/jhotdraw_pert.jar"/>
        </exec>
    </target>
    <target name="applet.jarsigned" depends="init,applet.jar">
        <copy tofile="${distdir}/signed/jhotdraw_pert.jar">
            <fileset file="${distdir}/unsigned/jhotdraw_pert.jar"/>
        </copy>
        <exec executable="pack200">
            <arg value="-r"/>
            <arg value="${distdir}/signed/jhotdraw_pert.jar"/>
        </exec>
          <signjar alias="${keystore.alias}" 
                storepass="${keystore.storepass}"
                keystore="${keystore.file}" 
                jar="${distdir}/signed/jhotdraw_pert.jar"
                tsaurl="${keystore.tsaurl}"
                >
        </signjar>        
        <exec executable="pack200">
            <arg value="${distdir}/signed/jhotdraw_pert.jar.pack.gz"/>
            <arg value="${distdir}/signed/jhotdraw_pert.jar"/>
        </exec>
    </target>
    <target name="application.compile" depends="init,clean">
        <mkdir dir="${classdir}"/>
        <javac
                destdir="${classdir}"
                srcdir="${srcdir}"
                
                debug="${javac.debug}"
                optimize="${javac.optimize}"
                encoding="${javac.encoding}"
                includeantruntime="${javac.includeantruntime}"
                source="${javac.source}"
                target="${javac.target}"
                bootclasspath="${javac.bootclasspath}"
                classpath="${javac.classpath}"
                extdirs="${javac.extdirs}"
         >
            <classpath path="${libdir}/quaqua.jar"/>
            <classpath path="${libdir}/java_30.zip"/>
            <classpath path="${libdir}/annotations.jar"/>
            <classpath path="${libdir}/jsr305.jar"/>
            <include name="net/n3/nanoxml/*.java"/> 
            <include name="org/jhotdraw/samples/pert/Main.java"/> 
            <include name="org/jhotdraw/samples/pert/PertProject.java"/> 
        </javac>
        <copy todir="${classdir}/org/jhotdraw/app/action/images">
            <fileset dir="${srcdir}/org/jhotdraw/app/action/images" />
        </copy>
        <copy todir="${classdir}/org/jhotdraw/app">
            <fileset dir="${srcdir}/org/jhotdraw/app">
                <include name="*.properties"/>
            </fileset>
        </copy>
        <copy todir="${classdir}/org/jhotdraw/draw/action/images">
            <fileset dir="${srcdir}/org/jhotdraw/draw/action/images" />
        </copy>
        <copy todir="${classdir}/org/jhotdraw/undo">
            <fileset dir="${srcdir}/org/jhotdraw/undo">
                <include name="*.properties"/>
            </fileset>
        </copy>
        <copy todir="${classdir}/org/jhotdraw/undo/images">
            <fileset dir="${srcdir}/org/jhotdraw/undo/images">
                <include name="*.png"/>
            </fileset>
        </copy>
        <copy todir="${classdir}/org/jhotdraw/app">
            <fileset file="${srcdir}/org/jhotdraw/app/Label*.properties"/>
        </copy>
        <copy todir="${classdir}/org/jhotdraw/draw">
            <fileset file="${srcdir}/org/jhotdraw/draw/Label*.properties"/>
        </copy> 
        <copy todir="${classdir}/org/jhotdraw/gui">
            <fileset file="${srcdir}/org/jhotdraw/gui/Label*.properties"/>
        </copy>
        <copy todir="${classdir}/org/jhotdraw/samples/pert">
            <fileset file="${srcdir}/org/jhotdraw/samples/pert/Label*.properties"/>
        </copy>
        <copy todir="${classdir}/org/jhotdraw/samples/pert/images">
            <fileset file="${srcdir}/org/jhotdraw/samples/pert/images/*.png"/>
        </copy>
    </target>
    <target name="application.jar" depends="init,application.compile">
        <mkdir dir="${distdir}/unsigned"/>
        <jar destfile="${distdir}/unsigned/JHotDraw PERT.jar" basedir="${classdir}">
            <manifest>
                <attribute name="Built-By" value="${author}"/>
                <attribute name="Main-Class" value="org.jhotdraw.samples.pert.Main"/>
                <attribute name="Class-Path" value="quaqua.jar lib/quaqua.jar ../lib/quaqua.jar ../../lib/quaqua.jar"/>
                <attribute name="Implementation-Version" value="${version}"/>
            </manifest>
        </jar>
        <copy todir="${distdir}/unsigned">
            <fileset file="${libdir}/*.jar"/>
            <fileset file="${libdir}/*.jnilib"/>
        </copy>
    </target>
    <target name="application.jarsigned" depends="init,application.jar">
        <unjar src="${libdir}/quaqua.jar" dest="${classdir}" />
        <jar destfile="${distdir}/signed/JHotDraw PERT.jar" basedir="${classdir}">
            <manifest>
                <attribute name="Built-By" value="${author}"/>
                <attribute name="Main-Class" value="org.jhotdraw.samples.pert.Main"/>
                <attribute name="Implementation-Version" value="${version}"/>
            </manifest>
        </jar>
        <exec executable="pack200">
            <arg value="-r"/>
            <arg value="${distdir}/signed/JHotDraw PERT.jar"/>
        </exec>
          <signjar alias="${keystore.alias}" 
                storepass="${keystore.storepass}"
                keystore="${keystore.file}" 
                jar="${distdir}/signed/JHotDraw PERT.jar"
                tsaurl="${keystore.tsaurl}"
                >
        </signjar>        
        <jar basedir="${libdir}" compress="true"
             jarfile="${distdir}/signed/libquaqua.jnilib.jar"
             >
            <include name="libquaqua.jnilib"/>
        </jar>
        <signjar alias="${keystore.alias}" 
            storepass="${keystore.storepass}"
            keystore="${keystore.file}" 
            jar="${distdir}/signed/libquaqua.jnilib.jar"
            tsaurl="${keystore.tsaurl}"
            >
        </signjar>        
        <jar basedir="${libdir}" compress="true"
             jarfile="${distdir}/signed/libquaqua64.jnilib.jar"
             >
            <include name="libquaqua64.jnilib"/>
        </jar>
        <signjar alias="${keystore.alias}" 
            storepass="${keystore.storepass}"
            keystore="${keystore.file}" 
            jar="${distdir}/signed/libquaqua64.jnilib.jar"
            tsaurl="${keystore.tsaurl}"
            >
        </signjar>        
    </target>
    <target name="application.run-jar" depends="init">
        <java fork="true" jar="${distdir}/unsigned/JHotDraw Pert.jar">
            <jvmarg value="-Xdock:name=JHotDraw Pert"/>
            <jvmarg value="-Dlocale=en"/>
            <jvmarg value="-Dapple.awt.graphics.UseQuartz=false"/>
            <jvmarg value="-Djava.library.path=${libdir}"/>
        </java>
    </target>
    <target name="application.run-compiled" depends="init">
        <java fork="true" classname="org.jhotdraw.samples.pert.Main">
            <classpath>
                <path path="${classdir}"/>
                <fileset dir="${libdir}">
                    <include name="*.jar"/>
                </fileset>
            </classpath>
            <jvmarg value="-Djava.library.path=${libdir}"/>
            <jvmarg value="-Xdock:name=JHotDraw Pert"/>
            <jvmarg value="-Dlocale=en"/>
            <jvmarg value="-Dapple.awt.graphics.UseQuartz=false"/>
        </java>
    </target>
    <target name="applet.run-jar" depends="init">
        <java fork="true" jar="${distdir}/unsigned/jhotdraw_pert.jar"/>
    </target>
    <target name="applet.run-compiled" depends="init">
        <java fork="true" classname="org.jhotdraw.samples.pert.PertApplet">
            <classpath>
                <pathelement path="${classdir}"/>
            </classpath>
        </java>
    </target>
    <target name="applet.appletviewer" depends="init">
        <exec executable="appletviewer">
        <arg value="${builddir}/PertApplet.html"/>
        </exec>
    </target>
    <target name="dist" depends="init,applet.jar,application.jar">
    </target>
    <target name="distsigned" depends="init,applet.jarsigned,application.jarsigned">
    </target>
</project>
